#include <iostream> 
#include <memory>
#include <vector>
 
using namespace std; 
 
struct Node {
  string name;
  shared_ptr<Node> left;
  weak_ptr<Node> right;

  explicit Node(string name) : name(name) {
    cout << "created node " << name << endl;
  }

  ~Node() {
    cout << "destroying node " << name << endl;
  }
};

// copy elision
shared_ptr<Node> buildGraph() {
  auto a = make_shared<Node>("a");
  auto b = make_shared<Node>("b");
  auto c = make_shared<Node>("c");
  auto d = make_shared<Node>("d");
  c->right = make_shared<Node>("e"); // BAD
  c->left = d;
  if (! c->right.expired()) {
    b->left = c->right.lock();
  } else {
    cout << "c->right is already destroyed\n";
  }
  a->right = b->left;
  d->left = make_shared<Node>("f");
  d->left->right = d;
  return b;
}

vector<int> foo() { return vector{1,2,3}; }
 
int main() { 
  auto x = buildGraph();
  auto g = make_shared<Node>("g");
  g->left = x;
  return 0;
}
